﻿using System;
using System.Linq;

using IdeaBlade.EntityModel;
using IdeaBlade.Core;

namespace DomainModel {

  public partial class Order {

    // Delete all order details for this order.
    public void DeleteGraph() {

      bool isPending = this.OrderDetails.IsPendingEntityList;
      if (isPending) {
        this.OrderDetails.PendingEntityListResolved += OrderDetails_PendingEntityListResolved;
      } else {
        DeleteGraphCore();
      }
    }

    private void DeleteGraphCore() {
      foreach (var dtl in this.OrderDetails.ToList()) {
        dtl.EntityAspect.Delete();
      }

      this.EntityAspect.Delete();
    }

    private void OrderDetails_PendingEntityListResolved(object sender, PendingEntityListResolvedEventArgs<OrderDetail> e) {
      DeleteGraphCore();
    }

  }
}
